diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/traffic-control/model/fq-pie-queue-disc.h ns-3.34/src/traffic-control/model/fq-pie-queue-disc.h
--- ns-3.33/src/traffic-control/model/fq-pie-queue-disc.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/traffic-control/model/fq-pie-queue-disc.h	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,209 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2016 Universita' degli Studi di Napoli Federico II
+ * Copyright (c) 2018 NITK Surathkal (modified for FQ-PIE)
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Authors: Pasquale Imputato <p.imputato@gmail.com>
+ *          Stefano Avallone <stefano.avallone@unina.it>
+ * Modified for FQ-PIE by:  Sumukha PK <sumukhapk46@gmail.com>
+ *                          Prajval M  <26prajval98@gmail.com>
+ *                          Ishaan R D <ishaanrd6@gmail.com>
+ *                          Mohit P. Tahiliani <tahiliani@nitk.edu.in>
+ */
+
+#ifndef FQ_PIE_QUEUE_DISC
+#define FQ_PIE_QUEUE_DISC
+
+#include "ns3/queue-disc.h"
+#include "ns3/object-factory.h"
+#include <list>
+#include <map>
+
+namespace ns3 {
+
+/**
+ * \ingroup traffic-control
+ *
+ * \brief A flow queue used by the FqPie queue disc
+ */
+
+class FqPieFlow : public QueueDiscClass
+{
+public:
+  /**
+   * \brief Get the type ID.
+   * \return the object TypeId
+   */
+  static TypeId GetTypeId (void);
+  /**
+   * \brief FqPieFlow constructor
+   */
+  FqPieFlow ();
+
+  virtual ~FqPieFlow ();
+
+  /**
+   * \enum FlowStatus
+   * \brief Used to determine the status of this flow queue
+   */
+  enum FlowStatus
+  {
+    INACTIVE,
+    NEW_FLOW,
+    OLD_FLOW
+  };
+
+  /**
+   * \brief Set the deficit for this flow
+   * \param deficit the deficit for this flow
+   */
+  void SetDeficit (uint32_t deficit);
+  /**
+   * \brief Get the deficit for this flow
+   * \return the deficit for this flow
+   */
+  int32_t GetDeficit (void) const;
+  /**
+   * \brief Increase the deficit for this flow
+   * \param deficit the amount by which the deficit is to be increased
+   */
+  void IncreaseDeficit (int32_t deficit);
+  /**
+   * \brief Set the status for this flow
+   * \param status the status for this flow
+   */
+  void SetStatus (FlowStatus status);
+  /**
+   * \brief Get the status of this flow
+   * \return the status of this flow
+   */
+  FlowStatus GetStatus (void) const;
+  /**
+   * \brief Set the index for this flow
+   * \param index the index for this flow
+   */
+  void SetIndex (uint32_t index);
+  /**
+   * \brief Get the index of this flow
+   * \return the index of this flow
+   */
+  uint32_t GetIndex (void) const;
+
+private:
+  int32_t m_deficit;    //!< the deficit for this flow
+  FlowStatus m_status;  //!< the status of this flow
+  uint32_t m_index;     //!< the index for this flow
+};
+
+
+/**
+ * \ingroup traffic-control
+ *
+ * \brief A FqPie packet queue disc
+ */
+
+class FqPieQueueDisc : public QueueDisc
+{
+public:
+  /**
+   * \brief Get the type ID.
+   * \return the object TypeId
+   */
+  static TypeId GetTypeId (void);
+  /**
+   * \brief FqPieQueueDisc constructor
+   */
+  FqPieQueueDisc ();
+
+  virtual ~FqPieQueueDisc ();
+
+  /**
+   * \brief Set the quantum value.
+   *
+   * \param quantum The number of bytes each queue gets to dequeue on each round of the scheduling algorithm
+   */
+  void SetQuantum (uint32_t quantum);
+
+  /**
+   * \brief Get the quantum value.
+   *
+   * \returns The number of bytes each queue gets to dequeue on each round of the scheduling algorithm
+   */
+  uint32_t GetQuantum (void) const;
+
+  // Reasons for dropping packets
+  static constexpr const char* UNCLASSIFIED_DROP = "Unclassified drop";  //!< No packet filter able to classify packet
+  static constexpr const char* OVERLIMIT_DROP = "Overlimit drop";        //!< Overlimit dropped packets
+
+private:
+  virtual bool DoEnqueue (Ptr<QueueDiscItem> item);
+  virtual Ptr<QueueDiscItem> DoDequeue (void);
+  virtual bool CheckConfig (void);
+  virtual void InitializeParams (void);
+
+  /**
+   * \brief Drop a packet from the head of the queue with the largest current byte count
+   * \return the index of the queue with the largest current byte count
+   */
+  uint32_t FqPieDrop (void);
+
+  /**
+   * Compute the index of the queue for the flow having the given flowHash,
+   * according to the set associative hash approach.
+   *
+   * \param flowHash the hash of the flow 5-tuple
+   * \return the index of the queue for the given flow
+   */
+  uint32_t SetAssociativeHash (uint32_t flowHash);
+
+  // PIE queue disc parameter
+  bool m_useEcn;             //!< True if ECN is used (packets are marked instead of being dropped)
+  double m_markEcnTh;        //!< ECN marking threshold (default 10% as suggested in RFC 8033)
+  Time m_ceThreshold;        //!< Threshold above which to CE mark
+  bool m_useL4s;             //!< True if L4S is used (ECT1 packets are marked at CE threshold)
+  Time m_sUpdate;            //!< Start time of the update timer
+  Time m_tUpdate;            //!< Time period after which CalculateP () is called
+  Time m_qDelayRef;          //!< Desired queue delay
+  uint32_t m_meanPktSize;    //!< Average packet size in bytes
+  Time m_maxBurst;           //!< Maximum burst allowed before random early dropping kicks in
+  double m_a;                //!< Parameter to pie controller
+  double m_b;                //!< Parameter to pie controller
+  uint32_t m_dqThreshold;    //!< Minimum queue size in bytes before dequeue rate is measured
+  bool m_useDqRateEstimator; //!< Enable/Disable usage of dequeue rate estimator for queue delay calculation
+  bool  m_isCapDropAdjustment; //!< Enable/Disable Cap Drop Adjustment feature mentioned in RFC 8033
+  bool m_useDerandomization; //!< Enable Derandomization feature mentioned in RFC 8033
+
+  // Fq parameters
+  uint32_t m_quantum;        //!< Deficit assigned to flows at each round
+  uint32_t m_flows;          //!< Number of flow queues
+  uint32_t m_setWays;        //!< size of a set of queues (used by set associative hash)
+  uint32_t m_dropBatchSize;  //!< Max number of packets dropped from the fat flow
+  uint32_t m_perturbation;   //!< hash perturbation value
+  bool m_enableSetAssociativeHash; //!< whether to enable set associative hash
+
+  std::list<Ptr<FqPieFlow> > m_newFlows;    //!< The list of new flows
+  std::list<Ptr<FqPieFlow> > m_oldFlows;    //!< The list of old flows
+
+  std::map<uint32_t, uint32_t> m_flowsIndices;    //!< Map with the index of class for each flow
+  std::map<uint32_t, uint32_t> m_tags;            //!< Tags used by set associative hash
+
+  ObjectFactory m_flowFactory;         //!< Factory to create a new flow
+  ObjectFactory m_queueDiscFactory;    //!< Factory to create a new queue
+};
+
+} // namespace ns3
+
+#endif /* FQ_PIE_QUEUE_DISC */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/traffic-control/model/pie-queue-disc.cc ns-3.34/src/traffic-control/model/pie-queue-disc.cc
--- ns-3.33/src/traffic-control/model/pie-queue-disc.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/traffic-control/model/pie-queue-disc.cc	2021-07-14 10:31:07.000000000 -0700
@@ -50,7 +50,7 @@
                    "Average of packet size",
                    UintegerValue (1000),
                    MakeUintegerAccessor (&PieQueueDisc::m_meanPktSize),
-                   MakeUintegerChecker<uint32_t> ())
+                   MakeUintegerChecker<uint32_t> ()) 
     .AddAttribute ("A",
                    "Value of alpha",
                    DoubleValue (0.125),
@@ -122,6 +122,16 @@
                    TimeValue (Time::Max ()),
                    MakeTimeAccessor (&PieQueueDisc::m_activeThreshold),
                    MakeTimeChecker ())
+    .AddAttribute ("CeThreshold",
+                   "The FqPie CE threshold for marking packets",
+                   TimeValue (Time::Max ()),
+                   MakeTimeAccessor (&PieQueueDisc::m_ceThreshold),
+                   MakeTimeChecker ())
+    .AddAttribute ("UseL4s",
+                   "True to use L4S (only ECT1 packets are marked at CE threshold)",
+                   BooleanValue (false),
+                   MakeBooleanAccessor (&PieQueueDisc::m_useL4s),
+                   MakeBooleanChecker ())
   ;
 
   return tid;
@@ -169,6 +179,24 @@
   NS_LOG_FUNCTION (this << item);
 
   QueueSize nQueued = GetCurrentSize ();
+  // If L4S is enabled, then check if the packet is ECT1, and if it is then set isEct true
+  bool isEct1 = false;
+  if (item && m_useL4s)
+    {
+      uint8_t tosByte = 0;
+      if (item->GetUint8Value (QueueItem::IP_DSFIELD, tosByte) && (((tosByte & 0x3) == 1) || (tosByte & 0x3) == 3))
+        {
+          if ((tosByte & 0x3) == 1)
+            {
+              NS_LOG_DEBUG ("Enqueueing ECT1 packet " << static_cast<uint16_t> (tosByte & 0x3));
+            }
+          else 
+            {
+              NS_LOG_DEBUG ("Enqueueing CE packet " << static_cast<uint16_t> (tosByte & 0x3));
+            }
+          isEct1 = true; 
+        }
+    }
 
   if (nQueued + item > GetMaxSize ())
     {
@@ -177,7 +205,9 @@
       m_accuProb = 0;
       return false;
     }
-  else if ((m_activeThreshold == Time::Max () || m_active) && DropEarly (item, nQueued.GetValue ()))
+  // isEct1 will be true only if L4S enabled as well as the packet is ECT1.
+  // If L4S is enabled and packet is ECT1 then directly enqueue the packet.
+  else if ((m_activeThreshold == Time::Max () || m_active) && !isEct1 && DropEarly (item, nQueued.GetValue ()))
     {
       if (!m_useEcn || m_dropProb >= m_markEcnTh || !Mark (item, UNFORCED_MARK))
         {
@@ -195,14 +225,14 @@
   if (m_activeThreshold != Time::Max () && !m_active && m_qDelay >= m_activeThreshold)
     {
       m_active = true;
-      m_qDelayOld = Time (Seconds (0));
+      m_qDelayOld = Seconds (0);
       m_dropProb = 0;
       m_inMeasurement = true;
       m_dqCount = 0;
       m_avgDqRate = 0;
       m_burstAllowance = m_maxBurst;
       m_accuProb = 0;
-      m_dqStart = Simulator::Now ().GetSeconds ();
+      m_dqStart = Now ();
     }
 
   // If queue has been Idle for a while, Turn OFF PIE
@@ -230,9 +260,9 @@
   m_dqCount = DQCOUNT_INVALID;
   m_dropProb = 0;
   m_avgDqRate = 0.0;
-  m_dqStart = 0;
+  m_dqStart = Seconds (0);
   m_burstState = NO_BURST;
-  m_qDelayOld = Time (Seconds (0));
+  m_qDelayOld = Seconds (0);
   m_accuProb = 0.0;
   m_active = false;
 }
@@ -312,11 +342,11 @@
     {
       if (m_avgDqRate > 0)
         {
-          qDelay = Time (Seconds (GetInternalQueue (0)->GetNBytes () / m_avgDqRate));
+          qDelay = Seconds (GetInternalQueue (0)->GetNBytes () / m_avgDqRate);
         }
       else
         {
-          qDelay = Time (Seconds (0));
+          qDelay = Seconds (0);
           missingInitFlag = true;
         }
       m_qDelay = qDelay;
@@ -398,7 +428,7 @@
   // Section 4.4 #2
   if (m_burstAllowance < m_tUpdate)
     {
-      m_burstAllowance =  Time (Seconds (0));
+      m_burstAllowance =  Seconds (0);
     }
   else
     {
@@ -449,8 +479,31 @@
     }
 
   Ptr<QueueDiscItem> item = GetInternalQueue (0)->Dequeue ();
-  double now = Simulator::Now ().GetSeconds ();
-  uint32_t pktSize = item->GetSize ();
+  NS_ASSERT_MSG (item != nullptr, "Dequeue null, but internal queue not empty");
+
+  // If L4S is enabled and packet is ECT1, then check if delay is greater
+  // than CE threshold and if it is then mark the packet,
+  // skip PIE steps, and return the item.
+  if (m_useL4s)
+    {
+      uint8_t tosByte = 0;
+      if (item->GetUint8Value (QueueItem::IP_DSFIELD, tosByte) && (((tosByte & 0x3) == 1) || (tosByte & 0x3) == 3))
+        {
+          if ((tosByte & 0x3) == 1)
+            {
+              NS_LOG_DEBUG ("ECT1 packet " << static_cast<uint16_t> (tosByte & 0x3));
+            }
+          else 
+            {
+              NS_LOG_DEBUG ("CE packet " << static_cast<uint16_t> (tosByte & 0x3));
+            }
+          if ((Now () - item->GetTimeStamp () > m_ceThreshold) && Mark (item, CE_THRESHOLD_EXCEEDED_MARK))
+            {
+              NS_LOG_LOGIC ("Marking due to CeThreshold " << m_ceThreshold.GetSeconds ());
+            }
+          return item;
+        }
+    }  
 
   // if not in a measurement cycle and the queue has built up to dq_threshold,
   // start the measurement cycle
@@ -458,30 +511,28 @@
     {
       if ( (GetInternalQueue (0)->GetNBytes () >= m_dqThreshold) && (!m_inMeasurement) )
         {
-          m_dqStart = now;
+          m_dqStart = Now ();
           m_dqCount = 0;
           m_inMeasurement = true;
         }
 
       if (m_inMeasurement)
         {
-          m_dqCount += pktSize;
+          m_dqCount += item->GetSize ();
 
           // done with a measurement cycle
           if (m_dqCount >= m_dqThreshold)
             {
-
-              double tmp = now - m_dqStart;
-
-              if (tmp > 0)
+              Time dqTime = Now () - m_dqStart;
+              if (dqTime > Seconds (0))
                 {
                   if (m_avgDqRate == 0)
                     {
-                      m_avgDqRate = m_dqCount / tmp;
+                      m_avgDqRate = m_dqCount / dqTime.GetSeconds ();
                     }
                   else
                     {
-                      m_avgDqRate = (0.5 * m_avgDqRate) + (0.5 * (m_dqCount / tmp));
+                      m_avgDqRate = (0.5 * m_avgDqRate) + (0.5 * (m_dqCount / dqTime.GetSeconds ()));
                     }
                 }
               NS_LOG_DEBUG ("Average Dequeue Rate after Dequeue: " << m_avgDqRate);
@@ -489,7 +540,7 @@
               // restart a measurement cycle if there is enough data
               if (GetInternalQueue (0)->GetNBytes () > m_dqThreshold)
                 {
-                  m_dqStart = now;
+                  m_dqStart = Now ();
                   m_dqCount = 0;
                   m_inMeasurement = true;
                 }
@@ -503,11 +554,11 @@
     }
   else
     {
-      m_qDelay = Time (Seconds (now - item->GetTimeStamp ().GetSeconds ()));
+      m_qDelay = Now () - item->GetTimeStamp ();
 
       if (GetInternalQueue (0)->GetNBytes () == 0)
         {
-          m_qDelay = Time (Seconds (0));
+          m_qDelay = Seconds (0);
         }
     }
   return item;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/traffic-control/model/pie-queue-disc.h ns-3.34/src/traffic-control/model/pie-queue-disc.h
--- ns-3.33/src/traffic-control/model/pie-queue-disc.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/traffic-control/model/pie-queue-disc.h	2021-07-14 10:31:07.000000000 -0700
@@ -98,6 +98,7 @@
   static constexpr const char* UNFORCED_DROP = "Unforced drop";  //!< Early probability drops: proactive
   static constexpr const char* FORCED_DROP = "Forced drop";      //!< Drops due to queue limit: reactive
   static constexpr const char* UNFORCED_MARK = "Unforced mark";  //!< Early probability marks: proactive
+  static constexpr const char* CE_THRESHOLD_EXCEEDED_MARK = "CE threshold exceeded mark";  //!< Early probability marks: proactive
 
 protected:
   /**
@@ -131,6 +132,7 @@
    */
   void CalculateP ();
 
+
   static const uint64_t DQCOUNT_INVALID = std::numeric_limits<uint64_t>::max();  //!< Invalid dqCount value
 
   // ** Variables supplied by user
@@ -148,6 +150,8 @@
   bool m_useDerandomization;                    //!< Enable Derandomization feature mentioned in RFC 8033
   double m_markEcnTh;                           //!< ECN marking threshold (default 10% as suggested in RFC 8033)
   Time m_activeThreshold;                       //!< Threshold for activating PIE (disabled by default)
+  Time m_ceThreshold;                           //!< Threshold above which to CE mark
+  bool m_useL4s;                                //!< True if L4S is used (ECT1 packets are marked at CE threshold)
 
   // ** Variables maintained by PIE
   double m_dropProb;                            //!< Variable used in calculation of drop probability
@@ -158,7 +162,7 @@
   BurstStateT m_burstState;                     //!< Used to determine the current state of burst
   bool m_inMeasurement;                         //!< Indicates whether we are in a measurement cycle
   double m_avgDqRate;                           //!< Time averaged dequeue rate
-  double m_dqStart;                             //!< Start timestamp of current measurement cycle
+  Time m_dqStart;                               //!< Start timestamp of current measurement cycle
   uint64_t m_dqCount;                           //!< Number of bytes departed since current measurement cycle starts
   EventId m_rtrsEvent;                          //!< Event used to decide the decision of interval of drop probability calculation
   Ptr<UniformRandomVariable> m_uv;              //!< Rng stream
